# Install dependencies only when needed
# FROM node:16-alpine AS deps
FROM --platform=$BUILDPLATFORM node:16-alpine AS deps
ARG TARGETPLATFORM
ARG BUILDPLATFORM
RUN echo "I am running on $BUILDPLATFORM, building for $TARGETPLATFORM" > /log
FROM node:16-alpine
COPY --from=deps /log /log


# Check https://github.com/nodejs/docker-node/tree/b4117f9333da4138b03a546ec926ef50a31506c3#nodealpine to understand why libc6-compat might be needed.
RUN apk add --no-cache libc6-compat
WORKDIR /app
COPY package.json yarn.lock ./
RUN yarn install --frozen-lockfile



# Rebuild the source code only when needed
# FROM node:16-alpine AS builder
FROM --platform=$BUILDPLATFORM node:16-alpine AS builder
ARG TARGETPLATFORM
ARG BUILDPLATFORM
RUN echo "I am running on $BUILDPLATFORM, building for $TARGETPLATFORM" > /log
FROM node:16-alpine
COPY --from=builder /log /log


WORKDIR /app
COPY --from=deps /app/node_modules ./node_modules
COPY . .

ARG DATABASE_TYPE
ARG BASE_PATH

ENV DATABASE_TYPE $DATABASE_TYPE
ENV BASE_PATH $BASE_PATH

ENV NEXT_TELEMETRY_DISABLED 1

RUN yarn build-docker



# # Production image, copy all the files and run next
# # FROM node:16-alpine AS runner
# FROM --platform=$BUILDPLATFORM node:16-alpine AS runner
# ARG TARGETPLATFORM
# ARG BUILDPLATFORM
# RUN echo "I am running on $BUILDPLATFORM, building for $TARGETPLATFORM" > /log
# FROM node:16-alpine
# COPY --from=runner /log /log
# 
# 
# WORKDIR /app
# 
# ENV NODE_ENV production
# ENV NEXT_TELEMETRY_DISABLED 1
# 
# RUN addgroup --system --gid 1001 nodejs
# RUN adduser --system --uid 1001 nextjs
# 
# RUN yarn add npm-run-all dotenv prisma
# 
# # You only need to copy next.config.js if you are NOT using the default configuration
# COPY --from=builder /app/next.config.js .
# COPY --from=builder --chown=nextjs:nodejs /app/public ./public
# COPY --from=builder /app/package.json ./package.json
# COPY --from=builder /app/prisma ./prisma
# COPY --from=builder /app/scripts ./scripts
# 
# # Automatically leverage output traces to reduce image size
# # https://nextjs.org/docs/advanced-features/output-file-tracing
# COPY --from=builder --chown=nextjs:nodejs /app/.next/standalone ./
# COPY --from=builder --chown=nextjs:nodejs /app/.next/static ./.next/static
# 
# USER nextjs
# 
# EXPOSE 3000
# 
# ENV PORT 3000
# 
# CMD ["yarn", "start-docker"]
